#include <bits/stdc++.h>

using namespace std;

int main(){

    int n, q, a, b;
    int rez;

    scanf("%d%d", &n, &q);
    int *niz = new int[n];
    for(int i = 0; i<n; i++){
        scanf("%d", niz+i);
    }
    for(int i =0; i<q; i++){
        scanf("%d%d", &a, &b);

        a--; b--;
        rez=niz[a];

        for(int j = a+1; j<=b; j++)
        {

            rez&=niz[j];
        }
        printf("%d\n", rez);
    }


    return 0;

}